﻿using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Data.SQLite;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;

namespace AffairsTest {
	class Program {
		static void Main(string[] args) {
			Create();
			Stopwatch watch = new Stopwatch();
			watch.Start();

			Add();

			watch.Stop();

			Console.WriteLine(watch.Elapsed);
			Console.ReadKey();

			DeleteOne();

			foreach (var each in GetGuid()) {
				Console.WriteLine(each.ToString());
			}
			Console.ReadKey();

			DeleteAll();
		}

		private static void Create() {
			if (!Directory.Exists(AppDomain.CurrentDomain.BaseDirectory + "Data")) {
				Directory.CreateDirectory(AppDomain.CurrentDomain.BaseDirectory + "Data");
				SQLiteConnection.CreateFile(AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3");
			}

			if (!File.Exists(AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3")) {
				string datasource = "Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3";
				SQLiteConnection conn = new SQLiteConnection(datasource);
				conn.Open();

				SQLiteCommand cmd = conn.CreateCommand();
				string sql = "Create TABLE Test(ID GUID PRIMARY KEY,Content INTEGER NOT NULL)";
				cmd.CommandText = sql;
				cmd.Connection = conn;
				cmd.ExecuteNonQuery();
				conn.Close();
			}
		}

		private static void Add() {
			using (SQLiteConnection conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3")) {
				conn.Open();
				SQLiteCommand cmd = conn.CreateCommand();
				DbTransaction trans = conn.BeginTransaction();	//延时事务
				try {
					for (int i = 0; i < 1000; i++) {
						cmd.CommandText = "insert into Test values(@ID,@Content)";
						cmd.Parameters.Add(new SQLiteParameter("@ID", Guid.NewGuid()));
						cmd.Parameters.Add(new SQLiteParameter("@Content", i));

						cmd.ExecuteNonQuery();
					}
					trans.Commit();	//提交事务
				} catch {
					trans.Rollback();	//事务回滚
					throw;
				}
			}
		}

		private static void DeleteOne() {
			using (SQLiteConnection conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3")) {
				conn.Open();
				SQLiteCommand cmd = conn.CreateCommand();
				cmd.CommandText = string.Format("delete from Test where Content=@value");
				cmd.Parameters.Add(new SQLiteParameter("@value", 100));
				cmd.ExecuteNonQuery();
			}
		}

		private static List<Guid> GetGuid() {
			using (SQLiteConnection conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3")) {
				List<Guid> list = new List<Guid>();
				conn.Open();
				SQLiteCommand cmd = conn.CreateCommand();
				cmd.CommandText = "select * from Test where Content=@content";
				cmd.Parameters.Add(new SQLiteParameter("content", 101));
				SQLiteDataReader dr = cmd.ExecuteReader();
				while (dr.Read()) {
					Guid ID = dr.GetGuid(0);
					list.Add(ID);
				}
				return list;
			}
		}

		private static void DeleteAll() {
			using (SQLiteConnection conn = new SQLiteConnection("Data Source=" + AppDomain.CurrentDomain.BaseDirectory + "Data\\test2.db3")) {
				conn.Open();
				SQLiteCommand cmd = conn.CreateCommand();
				cmd.CommandText = string.Format("delete from Test");
				cmd.ExecuteNonQuery();
			}
		}
	}
}
